# Copyright (C) 1999, 2000 Jay Beale
# Licensed under the GNU General Public License

package Bastille::PatchDownload;

use Bastille::IO;
@ENV="";
$ENV{PATH}="";
$ENV{CDPATH}=".";
$ENV{BASH_ENV}="";

&PatchDownload;


#######################################################################
##                            Patch Download                         ##
#######################################################################

# Download specific RPMs from RedHat's errata list
# We get the list of which ones to download from a Bastille/SANS web
# server, so as to avoid the question: "do we download all security
# patches indiscriminately, or do we put a static list in the script,
# for safety/predictability?

# TODO: Figure out _how_ to patch the kernel...
# TODO: Figure out how to secure this interaction...

sub PatchDownload {

   &ActionLog("# sub PatchDownload\n");
# We download the list of RPMs to upgrade from a Bastille/SANS site, 
# hardcoded as one of my web sites, until we get one, and then download
# only those RPMs for which the package was already installed.

print <<ENDPATCHNOW;

Patch Download:
Since RedHat 6.0/6.1 were released, security vulnerabilities have been found 
in a number of packages, usually system daemons, installed with Redhat.  New 
versions of these packages are on Redhat's "errata" page.  It is incredibly 
important to install the updated packages as soon as possible.  If you have a
fast network connection and can access web servers without a proxy server, we 
can download and install the new versions for you now.  

If you're using a phone modem to access the internet or you don't have 
networking working properly, please choose "No" to the next question.

                            WARNING: 


This script does not currently have a method for verifying that the patches
it downloads are authentic.  We download patches from a site we consider to
be generally secure and reliable, but that's not an absolute guarantee.  For
instance, if the RedHat web server we download from was cracked, the
attacker could place Trojan horses or otherwise false RPMs on the site.  We
include directions for getting these patches manually in the README.PATCH file.
You do need patches, though -- without patches, your risk of being hacked
is much higher.  You should only choose Yes here if you've weighed the risks.  

May we download and install the updated RPMs?  [Default:  No]
ENDPATCHNOW

   # Don't download patches for now -- we need a good site with secure d/l.
   if ( (&GetYN eq "Y" ) and (0) ) {
   #if (&GetYN eq "Y" ) {
      `./webget http://bastille-linux.sourceforge.net/BastilleRH60SecurityRPMS`;
      &B_open(*BRHSRPMS,"BastilleRH60SecurityRPMS");
      while ($rpmline=<BRHSRPMS>) {
         if ($rpmline =~ /^ftp:\/\/.*\/(.*)-.*-.*\.i386\.rpm$/) {
            print "Downloading updated rpm $rpmline\n";
	    &ActionLog("# Downloading updated rpm $rpmline\n");
	    `./webget $rpmline`;
#            `/bin/rpm -F $rpmline`;
	    &ActionLog("rpm -F $rpmline\n");
         }
      }

      &B_close(*BRHSRPMS);
      `/bin/rpm -F *.rpm`;
      `/bin/rm BastilleRedHatSecurityRPMS`;
   }
   else {
      # Deactivating patch downloads for now...
      print "We're not installing patches right now -- you should go and\n";
      print "download all the patches listed on Red Hat's distro page.\n\n";
      
      print "Please install patches manually, following directions in README.PATCH!\n";
   }

}

1;

